﻿###############################################################################################################
# Author. Luke Keam
# Company Name. Tech Geek
# Email. luke_keam@techgeek.biz
# Published. on 1/8/2016 AUS
# Version. 1.1
# Note. Questions, comments, suggestions always welcome. Please email me.
# Description. Script to add a new Admin account and then turn other accounts into standard
################################################################################################################

# Give the user an option of Admin$RadonString or own name
$RandomString = Get-Random -Maximum 10000
$RandomAdminName =  "Admin$RandomString"
$UserNameChoice = Read-Host "(1) Make your own Admin Name
(2) Have Admin$RandomString as your Admin Name
Please Enter 1 or 2 "
    if ($UserNameChoice -eq "1") {
        $AdminName = Read-host "Please Type your new Admin Name. " 
    } 
    elseif ($UserNameChoice -eq "2") {
        write-host "Offsite Selected"
        $AdminName = $RandomAdminName
    } 
    else {
        write-host "try again"
    }
    

#  Add -AsSecureString string and  -ConvertFrom-SecureString and compare
# No minimum password length on standard windows computers. what crap
do {
    $Password = Read-Host -Prompt "Your new Admin user is $AdminName. 
Enter Secure passphrase. Please Don't forget it 
(Write down your Username and Password and put it somewhere secure)
Password " 
    $ConfirmPassword = Read-Host -Prompt "Confirm Password " 
    }
    until ($Password -eq $ConfirmPassword) { 
    }
    
    
    
$AdminstratorGroupUsers = net localgroup Administrators
$LogFile = "C:\Program Files\Tech Geek\NewAdminDisableOtherAdmins\NewAdminDisableOtherAdminsrLog.txt"
   

# Checking for folder and making it if not
$TechGeekFolder = test-path 'C:\Program Files\Tech Geek'
    if ($TechGeekFolder -ne "True") {
        mkdir 'C:\Program Files\Tech Geek' | Out-Null
    } 
    
    $TechGeekFolderNewAdmin = test-path "C:\Program Files\Tech Geek\NewAdminDisableOtherAdmins"
        if ($TechGeekFolderNewAdmin -ne "True") {
            mkdir "C:\Program Files\Tech Geek\NewAdminDisableOtherAdmins" | Out-Null
        }
 

#  Starting Script
write-host "Starting" | 
    Out-File -Encoding ascii -FilePath $LogFile 
     
# User Add
    # Check and Log Current Users
    net user | 
        Out-File -Append -Encoding ascii -FilePath $LogFile 

    # Adding new Admin User
    net user "$AdminName" "$Password" /add /Y |
        Out-File -Append -Encoding ascii -FilePath $LogFile 
       
# Group Add
    # Check and Log Current Users of Administrators Group
    write-host "Administrators Group Members" | 
        Out-File -Append -Encoding ascii -FilePath $LogFile 

    net localgroup Administrators | 
        Out-File -Append -Encoding ascii -FilePath $LogFile

    # Add New Admin to Administrators Group
    net localgroup Administrators $AdminName /add | Out-Null

# Check to see if new admin has been added to adminsitrators group then remove other admins
$AdminsInAdminGroup =  Get-WmiObject win32_groupuser | 
    Where-Object { $_.GroupComponent -match 'administrators' } | 
    ForEach-Object {[wmi]$_.PartComponent } 
                
    if ($AdminsInAdminGroup | where {$_.Name -eq $AdminName}) {
        write-host "$AdminName is now in the Adminsistrators Group!" 
            
        # Filter Out new Admin and BuiltIn Admin
        $DeletedAdmins = $AdminsInAdminGroup |
            Where-Object -FilterScript {$_.Name -ne "$AdminName"} |
            Where-Object -FilterScript {$_.Name -ne "Administrator"}
                
        # Remove Other Users From Administrators Group   
        $DeletedAdmins | 
            foreach { net localgroup Administrators $_.Name  /delete} | 
                Out-File -Append -Encoding ascii -FilePath $LogFile 

        # Disable Built In Administrators account   
        net user Administrator /active:no | 
            Out-File -Append -Encoding ascii -FilePath $LogFile      

    } 
    elseif ($AdminsInAdminGroup | where {$_.Name -ne $AdminName}) {
        Write-Host "$AdminName is not in the Adminsistrators Group! Holy Smokes. Exiting Now"
        Exit
    } 
    else {
        Write-Host "Something went wrong"
        Exit
    }

#  Log finsh
add-content -Path $LogFile -Value "$AdminName is the new Admin"
add-content -Path $LogFile -Value "Finished Succesfully" -passthru
add-content -Path $LogFile -Value (get-date -Format g) 

Write-Host "Press Any Key to Exit ..."
$x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")